module MPYdata (RESET, CLK, START, INP, SM, PROD );
`include "MPYdefs.v"
  input RESET, CLK, START;
  input [MPYmsb:0] INP;
  input [SMmsb:SMlsb] SM;
  output [PRODmsb:0] PROD;
  reg [MPYmsb:0] MPY, MCND, HPROD;
  wire [MPYmsb+1:0] F;

  always @ (posedge CLK) // implement registers
    if (RESET)         // clear registers on reset
      begin MPY  <= 0; MCND <= 0; HPROD <= 0; end 
    else if ((SM==IDLE) && START)  // load MCND, clear HPROD
      begin MCND <= INP; HPROD <= 0; end
    else if (SM==INIT) MPY <= INP; // load MPY
    else if (SM==RUN) begin        // shift registers
      MPY <= {F[0], MPY[MPYmsb:1]};
      HPROD <= F[(MPYmsb+1):1];  end

  assign F = (MPY[0]) ? ({1'b0, HPROD} + {1'b0, MCND}) : {1'b0, HPROD};
  assign PROD = {HPROD, MPY};
endmodule